<template>
	<mind-layout-table :data="ListaRecursos" rowKey="id" 
		:action-add="false" :action-edit="false" :action-delete="false"
		:path="$route.path" @delete="onDelete" >
		<template slot="actions" slot-scope="{selectedRow}">
			<el-button 
				type="primary" 
				plain 
				icon="el-icon-refresh" 
				size="small" 
				@click="fetch(selectedRow)"
				>Actualizar
			</el-button>

		</template>
		<template>
			<el-table-column width="220" sortable prop="module" label="Module"  />
			<el-table-column sortable prop="description" label="Description"  />
			<!-- <el-table-column width="100" prop="useCount" label="Use Count"  /> -->
			<el-table-column sortable width="120" prop="status" label="Status"  />
			<el-table-column sortable width="150" prop="supportLevel" label="Support Level"  />
			<el-table-column width="50"  label="">
				<template slot-scope="{row}">
					<el-button type="primary" 
						icon="el-icon-refresh-right" plain size="mini" circle 
						@click="reload(row.module)"/>
				</template>
			</el-table-column>
		</template>
	</mind-layout-table>
</template>

<script>
import store from '@/store/modules'
import {Rest} from '@/../modules/mind-core-vue'

export default {
  async created() {
		store.idAgencia = 1

		this.api = new Rest({
			uri: `/api/asterisk/ami/modules`, 
			state: store.data,
			key: 'id'})
		this.fetch()
	},
	computed:{
		ListaRecursos() {
			let lista = []
			if(!store.data.RESOURCE_LIST) {
				return []
			}
			for(const r of store.data.RESOURCE_LIST) {
				lista.push({
					...r})
			}
			return lista
		},
	},
	methods: {
		/**
		 * Elimina el recuros especificado
		 * @param id recurso del elemento a eliminar
		 */
		onDelete(id){
			this.api.Delete(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
		//recarga el modulo especificado
		reload(module) {
			this.api.Post(null, { uri: `${this.api.uri}/reload/${module}`})
				.then(()=> {
					this.$message({
						showClose: true,
						type: 'success',
						message: "Módulo Recargado Correctamente"
					});
				})
				.catch((error) => {
					this.$message({
						showClose: true,
						type: 'error',
						message: error
					});
				})
		},
		fetch() {
			this.api.FetchAll().catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		}
	},
	data() {
		return {
			api: null,
		}
	}
	
}
</script>
<style >
	.el-table .disabled {
    /* background: #f0f9eb; */
		text-decoration: line-through;
		color: rgb(158, 154, 154);
	}
</style>
